//Piezo-Loch in Deckel
//Sockel

bauch=70;
kopf=50;
arme=20;
armwinkel=55;
armhoehe=-25;
augen=12;
augenwinkel=45;
augenhoehe=-19; //Grad nach oben
nase=12;
nabel=10;
nabelhoehe=27; //Grad nach unten
wand=1.6;
servoBohr=2.7;
sockelbodenH=4.6;
sockelbodenPlatte=1.6;
sockelschraubenkopf=14;
taster=6.5;

fn=70;
fn2=50;
tiefe=5;
servoH=23;
servoB=12.5;
rwand=3.5;
led=3.2;

*rotate([270,0,0])
difference() {
    union() { //Hase Gehäuse
        difference(){
            union(){
                sphere(d=bauch, $fn=fn*1.3);  
                      
                rotate([armhoehe,0, armwinkel])
                  translate([0, -bauch/2+arme/8, 0])
                    sphere(d=arme, $fn=fn2);
                    
                rotate([armhoehe,0, -armwinkel])
                  translate([0, -bauch/2+arme/8, 0])
                    sphere(d=arme, $fn=fn2);

                *rotate([nabelhoehe,0, 0])
                  translate([0, -bauch/2+nabel/4, 0])
                    sphere(d=nabel, $fn=fn2);

                //Füße    
                translate([bauch/3.8, 0,-bauch/2, ])
                    scale([1,4,1])
                        sphere(d=16, $fn=fn2);
                translate([-bauch/3.8, 0,-bauch/2, ])
                    scale([1,4,1])
                        sphere(d=16, $fn=fn2);

                //Ziffern    
                color("red")
                intersection(){
                    rotate([17,0,0])
                        translate([0, -bauch/2+5, 0]) {
                            rotate([90,0,0])
                            linear_extrude(height = 6) {
                                text("3  5  7", font = "Liberation Sans:style=Bold", 
                                            size = 6.7, halign ="center");
                            }
                         }
                     sphere(d=bauch+2, $fn=fn*1.3);       
                }        
            }        
            //aushöhlen
            sphere(d=bauch-wand*2, $fn=fn);

            //Loch im Fuß
            translate([bauch/3-7,0,-bauch/2-2])
            rotate([0,-10,0])
            cylinder(d=6, h=10, $fn=24);    

            translate([bauch/3-6,-10,-bauch/2-2])
                cylinder(d=3.4, h=15, $fn=24);    
            translate([-bauch/3+6,-10,-bauch/2-2])
                cylinder(d=3.4, h=15, $fn=24);    
            //Leds
                rotate([90,0,0])
                    cylinder(d=led, h=50, $fn=32);
                rotate([90,0,17])
                    cylinder(d=led, h=50, $fn=32);
                rotate([90,0,-17])
                    cylinder(d=led, h=50, $fn=32);
            //Hinten abschneiden
            translate([-50,tiefe,-50])
                cube(100,100,100);

            //Unten abschneiden
            translate([-50,-50,-bauch*2+4])
                cube(100,100,100);
        }
        //Bolzen unten rechts
        translate([-bauch/3+2,tiefe,-bauch/3+3])
        rotate([90,0,0])
        difference() {
            cylinder(d=9, h=12,$fn=24);    
            translate([0,0,-1])
            cylinder(d=2.7, h=20,$fn=16);    
        }

        //Bolzen unten links
        translate([bauch/3-2,tiefe,-bauch/3+3])
        rotate([90,0,0])
        difference() {
            cylinder(d=9, h=12,$fn=24);    
            translate([0,0,-1])
            cylinder(d=2.7, h=20,$fn=16);    
        }
        //Kopf
        translate([0,0,bauch/2+kopf/2-wand*1.6]){
            difference(){
                union(){
                    sphere(d=kopf, $fn=fn);    
                    translate([0,-kopf/2+1,0])
                      sphere(d=nase, $fn=fn2);
                    
                    rotate([augenhoehe,0, augenwinkel])
                      translate([0, -kopf/2+augen/4, 0])
                        sphere(d=augen, $fn=fn2);
                    rotate([augenhoehe,0, -augenwinkel])
                      translate([0, -kopf/2+augen/4, 0])
                        sphere(d=augen, $fn=fn2);
                }
                
                sphere(d=kopf-wand*2, $fn=fn);
                translate([-50,tiefe,-50])
                cube(100,100,100);
            }
            //Bolzen Kopf
            translate([-kopf/3+3,tiefe,-kopf/3+3])
            rotate([90,0,0])
            difference() {
                cylinder(d=9, h=12, $fn=24);    
                translate([0,0,-1])
                cylinder(d=2.7, h=20,$fn=16);    
            }
        }
    }
    translate([0,3,bauch/2-5])
        cylinder(d=12, h=10);
}

*union() { //Rückenplatte
    difference(){
        union(){
            sphere(d=bauch, $fn=fn);  

            //Füße    
            translate([bauch/3.8, 0,-bauch/2, ])
                scale([1,4,1])
                    sphere(d=16, $fn=fn2);
            translate([-bauch/3.8, 0,-bauch/2, ])
                scale([1,4,1])
                    sphere(d=16, $fn=fn2);


        }        
        //sphere(d=bauch-wand*2);
        //vorn abschneiden
        translate([-50,-100+tiefe,-50])
            cube(100,100,100);
        //hinten abschneiden
        translate([-50,tiefe+rwand,-50])
            cube(100,100,100);

        translate([-50,-50,-bauch*2+4])
            cube(100,100,100);
        


        //Bolzen unten rechts
        translate([-bauch/3+2,tiefe+10,-bauch/3+3])
        rotate([90,0,0])
            cylinder(d=3.6, h=20,$fn=16);    

        //Bolzen unten links
        translate([bauch/3-2,tiefe+10,-bauch/3+3])
        rotate([90,0,0])
            cylinder(d=3.6, h=20,$fn=16);    

        
    }
    
    //Kopf
    translate([0,0,bauch/2+kopf/2-wand*1.6]){
        difference(){
            union() {
                //Kopf
                sphere(d=kopf, $fn=fn);    
                //Ohr fest
                color("red")
                rotate([0,60,0])
                translate([-25,wand*2.6+1.4,0])
                difference(){
                    scale([45,wand*2,6])
                        sphere(1, $fn=50);
                    translate([0,-wand,0])
                    scale([45-wand,wand,6-wand])
                        sphere(1, $fn=50);
                }
            }
            //vorn abschneiden
            translate([-50,-150+tiefe,-50])
            cube(150);

            //hinten abschneiden
            translate([-50,tiefe+rwand,-50])
                cube(150);
            
            //Servo-Loch
            translate([0,-5, -9])
            cube([servoB, 20,servoH]);
            //Servo-Bohrungen        
            translate([servoB/2,10, -9.0-2.5])
            rotate([90,0,0])
                cylinder(d=servoBohr, h=10, $fn=24);
            translate([servoB/2,10, servoH-9+2.5])
            rotate([90,0,0])
                cylinder(d=servoBohr, h=10, $fn=24);
            
            //Bolzenloch
            translate([-kopf/3+3,tiefe+10,-kopf/3+3])
            rotate([90,0,0])
                cylinder(d=3.6, h=20,$fn=16);    
            
        }
        
    }
}


//Ohr beweglich
union(){
    rotate([90,0,0]){
                    
                    color("pink")
                    rotate([0,130,0])
                    translate([-25,wand*2,0])
                    difference(){
                        translate([-25,0,0])
                            cube([65,wand*2,6*2], center=true);
                        difference(){
                            translate([0,-wand,0])
                                scale([45-wand,wand,6-wand])
                                    sphere(1, $fn=50);
                            translate([-13,-wand*2,-7])
                            cube([30,10,15]);
                        }
                    }
                                   
                    translate([37+11.4,wand,50+13.45])
                    color("green")
                        translate([0,0,3.5])
                            rotate([0,70,0])
                                cube([12,wand*2, 30,]);
    }


    //Knopf am Ohr 
    translate([72,-69,6.75])
    rotate([180,0,0]){
        cylinder(d=11, h=1.21, $fn=28);
        translate([0,0,1.2])
            cylinder(d1=11, d2=5, h=0.8, $fn=28);
    }
    translate([34,-40,6.75])
    rotate([180,0,0]){
        cylinder(d=11, h=1.21, $fn=28);
        translate([0,0,1.2])
            cylinder(d1=11, d2=5, h=0.8, $fn=28);
    }
}            
//Sockel
*color("green")
union(){
    difference(){            
        union(){
             translate([0,bauch/2-wand-taster,0])
                cylinder(d=16, h=3, $fn=16);      //Taster-Verdickung      
            cylinder(d=bauch, h=2.0, $fn=60);   
        }         
        translate([bauch/3-6,10,-1])
            cylinder(d=3.4, h=15, $fn=24);    
        translate([-bauch/3+6,10,-1])
            cylinder(d=3.4, h=15, $fn=24);    
        translate([bauch/3-7,0,-1])
            rotate([0,-10,0])
                cylinder(d=6, h=10, $fn=24);    

        //Taster
        translate([0,bauch/2-wand-taster-2,-1])
            cylinder(d=taster, h=10, $fn=16);            
    }            
    difference(){            
        cylinder(d=bauch, h=45, $fn=50);            
        translate([0,0,-1])
            cylinder(d=bauch-wand*2, h=62, $fn=50);            
    }

    translate([bauch/2-5,0,0])
        difference(){            
            cylinder(d=9, h=45, $fn=16);            
            translate([0,0,-1])
                cylinder(d=3.5, h=62, $fn=16);            
        }
    translate([-bauch/2+5,0,0])
        difference(){            
            cylinder(d=9, h=45, $fn=16);            
            translate([0,0,-1])
                cylinder(d=3.5, h=62, $fn=16);            
        }
}

//Sockelboden
*color("gray"){
    difference(){            
        cylinder(d=bauch, h=sockelbodenH, $fn=60);            

        translate([bauch/2-5,0,2]){
           cylinder(d=sockelschraubenkopf, h=10, $fn=16);            
           translate([0,0,-3])
                cylinder(d=4.5, h=10, $fn=16);            
        }
        translate([-bauch/2+5,0,2]){
           cylinder(d=sockelschraubenkopf, h=10, $fn=16);            
           translate([0,0,-3])
                cylinder(d=4.5, h=10, $fn=16);            
        }
        translate([0,0,sockelbodenPlatte])
            cylinder(d=bauch-wand*3, h=10, $fn=50);            
    }
    rotate([0,0,90])
    translate([-(bauch-wand)/2,0,0])
    cube([bauch-wand,2,sockelbodenH]);
}
